% Approximation of values (x(i),y(i)), for i=1,2,...,N by a
% polynomial f(x)=a(1)*x^M+a(2)*x^(M-1)+ ... a(M)*x+a(M+1) for M=1
% Definition of given values
    x=[0 0.2 0.5 0.7 0.8 1 1.2 1.6 1.9 2]';
    y=[5.2 4.3 4.4 4.9 5.5 6 6.2 8.4 8.9 10.9]';
% Evaluation of coefficients a and values of
% the approximation function
    a=polyfit(x,y,1), xx=[0:0.05:2]'; f=polyval(a,xx);
% Evaluation of the sum of square errors for given ranges
% of parameters a1, a2 and plot of results
    a1=2:0.1:4; a2=2.5:0.1:4.5;
    for i=1:21
      for j=1:21
        S(i,j)=sum((a1(j)*x+a2(i)-y).^2);
      end;
    end
    subplot(2,2,2)
        plot(xx,f); hold on; stem(x,y); hold off;
        xlabel('x'); ylabel('y'); title('APPROXIMATION'); grid on
    subplot(1,2,1)
        mesh(a2,a1,S)
        grid on; xlabel('a2'); ylabel('a1'); title('ERROR SURFACE');
    subplot(2,2,4)
        contour(a2,a1,S); grid on
        xlabel('a2'); ylabel('a1'); title('CONTOUR PLOT');